<?php
////转码
///
/**
 * 汉字转Unicode编码
 * @param string $str 原始汉字的字符串
 * @param string $encoding 原始汉字的编码
 * @param boot $ishex 是否为十六进制表示（支持十六进制和十进制）
 * @param string $prefix 编码后的前缀
 * @param string $postfix 编码后的后缀
 */
function unicode_encode($str, $encoding = 'UTF-8', $ishex = false, $prefix = '&#', $postfix = ';')
{
    $str =is_array($str)?$str[0]: $str;
    $str = mb_convert_encoding($str, 'UCS-4',$encoding );

    $arrstr = str_split($str, 4);

    $unistr = '';

    for ($i = 0, $len = count($arrstr); $i < $len; $i++) {

        $dec = $ishex ? bin2hex($arrstr[$i]) : hexdec(bin2hex($arrstr[$i]));

        $unistr .= $prefix . $dec . $postfix;

    }

    return $unistr;
}

?>